unit ArrowGenerator1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
		Spin, BGRABitmap, BGRABitmapTypes;

type

		{ TForm1 }

  TForm1 = class(TForm)
				Button1: TButton;
				Button2: TButton;
				Button3: TButton;
				CheckBox1: TCheckBox;
				CheckBox2: TCheckBox;
				CheckBox3: TCheckBox;
				CheckBox4: TCheckBox;
				CheckBox5: TCheckBox;
				CheckBox6: TCheckBox;
				ColorButton1: TColorButton;
				ColorButton2: TColorButton;
				ComboBox1: TComboBox;
				ComboBox2: TComboBox;
				FloatSpinEdit1: TFloatSpinEdit;
				FloatSpinEdit10: TFloatSpinEdit;
				FloatSpinEdit11: TFloatSpinEdit;
				FloatSpinEdit12: TFloatSpinEdit;
				FloatSpinEdit13: TFloatSpinEdit;
				FloatSpinEdit2: TFloatSpinEdit;
				FloatSpinEdit3: TFloatSpinEdit;
				FloatSpinEdit4: TFloatSpinEdit;
				FloatSpinEdit5: TFloatSpinEdit;
				FloatSpinEdit6: TFloatSpinEdit;
				FloatSpinEdit7: TFloatSpinEdit;
				FloatSpinEdit8: TFloatSpinEdit;
				FloatSpinEdit9: TFloatSpinEdit;
				GroupBox1: TGroupBox;
				GroupBox2: TGroupBox;
				GroupBox3: TGroupBox;
				Image1: TImage;
				Label1: TLabel;
				Label10: TLabel;
				Label11: TLabel;
				Label12: TLabel;
				Label13: TLabel;
				Label2: TLabel;
				Label3: TLabel;
				Label4: TLabel;
				Label5: TLabel;
				Label6: TLabel;
				Label7: TLabel;
				Label8: TLabel;
				Label9: TLabel;
				Panel1: TPanel;
				Panel2: TPanel;
				SpinEdit1: TSpinEdit;
				SpinEdit2: TSpinEdit;
				procedure Button1Click(Sender: TObject);
				procedure Button2Click(Sender: TObject);
				procedure Button3Click(Sender: TObject);
				procedure ComboBox1Change(Sender: TObject);
				procedure ComboBox2Change(Sender: TObject);
				procedure FormCreate(Sender: TObject);
				procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
						Shift: TShiftState; X, Y: Integer);
    procedure showPoints;
  private
    bmp: TBGRAbitmap;
    startP, EndP : TPoint;
    setStart, setEnd : boolean;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var R : Trect;
    Hollow :  Boolean;
    P0,P1 : TPointF;

begin
 bmp := TBGRAbitmap.create (Image1.Width, Image1.height, ColorButton2.ButtonColor);
 Hollow := FloatSpinEdit3.value > 0;
 Case ComboBox1.ItemIndex of
 0: bmp.ArrowStartAsNone;
 1: bmp.ArrowStartAsClassic(CheckBox1.Checked,CheckBox2.Checked,FloatSpinEdit1.value);
 2: bmp.ArrowStartAsTriangle(FloatSpinEdit2.value,CheckBox3.checked, Hollow,
                                                     FloatSpinEdit3.value);
 3: bmp.ArrowStartAsTail;
	end;

 Hollow := FloatSpinEdit6.value > 0;
 Case ComboBox2.ItemIndex of
 0: bmp.ArrowEndAsNone;
 1: bmp.ArrowEndAsClassic(CheckBox4.checked,CheckBox5.checked,FloatSpinEdit4.value);
 2: bmp.ArrowEndAsTriangle(FloatSpinEdit5.value,CheckBox6.Checked, hollow,
                                                       FloatSpinEdit6.value);
 3: bmp.ArrowEndAsTail;
	end;

 bmp.ArrowStartSize:= PointF (FloatSpinEdit8.value,FloatSpinEdit9.value);
 bmp.ArrowStartOffset:= FloatSpinEdit10.value;
 bmp.ArrowStartRepeat:= SpinEdit1.Value;
 bmp.ArrowEndSize := PointF (FloatSpinEdit11.value, FloatSpinEdit12.value);
 bmp.ArrowEndOffset:= FloatSpinEdit13.value;
 bmp.ArrowEndRepeat:= SpinEdit2.value;

 P0 := PointF (StartP);
 P1 := PointF(EndP);
 bmp.DrawLineAntialias(P0.x,P0.y,P1.x,P1.y,ColorButton1.ButtonColor,
                                                         FloatSpinEdit7.value);
R := Rect (0,0,bmp.width,bmp.height);
Image1.Canvas.CopyRect(R,bmp.canvas,R);
bmp.free;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  setStart := true;
  showMessage ('Click on Image for new Start Point');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  setEnd := true;
  showMessage ('Click on Image for new End Point');
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var  idx: Integer;
begin
  idx :=ComboBox1.ItemIndex;
  CheckBox1.Visible:= idx =1;
  CheckBox2.Visible:= idx = 1;
  CheckBox3.Visible:= idx= 2;
  FloatSpinEdit1.visible := idx= 1;
  Label1.Visible:= idx= 1;
  FloatSpinEdit2.visible := idx=2;
  Label2.Visible:= idx= 2;
  FloatSpinEdit3.visible := idx=2;
  Label3.Visible:= idx= 2;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
var  idx: Integer;
begin
idx :=ComboBox2.ItemIndex;
CheckBox4.Visible:= idx =1;
  CheckBox5.Visible:= idx = 1;
  CheckBox6.Visible:= idx= 2;
  FloatSpinEdit4.visible := idx= 1;
  Label4.Visible:= idx= 1;
  FloatSpinEdit5.visible := idx=2;
  Label5.Visible:= idx= 2;
  FloatSpinEdit6.visible := idx=2;
  Label6.Visible:= idx= 2;
end;

procedure TForm1.showPoints;
begin
image1.Canvas.Brush.color := clWhite;
Image1.Canvas.FillRect (0,0, image1.width, image1.Height);
image1.Canvas.Brush.color := clBlack;
Image1.Canvas.EllipseC(startP.x, StartP.y,6,6);
Image1.Canvas.EllipseC(EndP.x, EndP.y,6,6);
Button2.Caption := 'Start '+IntToStr(startP.x)+'/'+IntToStr(StartP.y);
Button3.Caption := 'End '+IntToStr(EndP.x)+'/'+IntToStr(EndP.y);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox1.ItemIndex := 2;
  ComboBox1Change(Nil);
  ComboBox2.ItemIndex := 1;
  ComboBox2Change(Nil);
  StartP := Point(30,40);
  EndP := Point(500,250);
  showPoints;
  setStart := false;
  setEnd := false;
  ColorButton2.ButtonColor:= CSSNavajoWhite;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
		Shift: TShiftState; X, Y: Integer);
begin
  if setStart or setEnd then
    begin
    if setStart then StartP := Point(x,y);
    if setEnd then EndP := Point(x,y);
    setStart := false;
    setEnd := false;
    showPoints;
				end;
end;

end.

